INSERT INTO activities(user, activity, ts)
SELECT :user, :activity, COALESCE(CASE COALESCE(:ts, '')
  WHEN '' THEN NULL
  ELSE datetime(:ts, 'utc')
END, CURRENT_TIMESTAMP)
WHERE COALESCE(:activity, '') <> ''
RETURNING 'redirect' AS component, '/' AS link
;

SET ":user" = 'shannon';
SET ":title" = 'Activities';
SELECT 'shell' AS component
, 'dark' AS theme
, :title AS title
;

SELECT 'form' AS component;
SELECT 'select' AS type
, 'Activity' AS label
, 'activity' AS name
, TRUE AS create_new
, TRUE AS dropdown
, (SELECT json_group_array(json_object(
    'label', activity,
    'value', activity,
    'selected', activity = 'Unknown'
  )) FROM activities WHERE user = :user
) AS options
, 8 AS width
;
SELECT 'datetime-local' AS type
, 'ts' AS name
, 'Date and Time' AS label
, '' AS value
, 4 AS width
;SELECT 'card' AS component
, 1 AS columns
;

SELECT date(datetime(CURRENT_TIMESTAMP, '-'|| value ||'  days')) AS title
, '/chart.sql'||
'?user='||:user||
'&date='|| REPLACE(datetime(CURRENT_TIMESTAMP, '-'|| value ||'  days'), ' ', '+') ||
'&_sqlpage_embed' AS embed
FROM json_each(json('[0, 1, 2, 3, 4, 5, 6, 7]'))
;
